'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _actions = require('./actions');

var _actions2 = _interopRequireDefault(_actions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var readModelPropsNames = ['readModelName', 'resolverName', 'variables', 'isReactive'];

var compareReadModelProps = function compareReadModelProps(nextProps, prevProps) {
  return readModelPropsNames.reduce(function (acc, key) {
    return acc && (0, _stringify2.default)(nextProps[key]) === (0, _stringify2.default)(prevProps[key]);
  }, true);
};

var extractReadModelProps = function extractReadModelProps(props) {
  return readModelPropsNames.reduce(function (acc, key) {
    acc[key] = props[key];
    return acc;
  }, {});
};

var extractReadModelValues = function extractReadModelValues(props) {
  return readModelPropsNames.map(function (key) {
    return props[key];
  });
};

exports.default = function (mapStateToProps, mapDispatchToProps, mergeProps, options) {
  return function (Component) {
    var ConnectedComponent = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps, options)(Component);

    var ReadModelConnector = function (_React$PureComponent) {
      (0, _inherits3.default)(ReadModelConnector, _React$PureComponent);

      function ReadModelConnector() {
        (0, _classCallCheck3.default)(this, ReadModelConnector);
        return (0, _possibleConstructorReturn3.default)(this, (ReadModelConnector.__proto__ || (0, _getPrototypeOf2.default)(ReadModelConnector)).apply(this, arguments));
      }

      (0, _createClass3.default)(ReadModelConnector, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          var readModelProps = extractReadModelProps(mapStateToProps(this.context.store.getState(), nextProps));

          if (compareReadModelProps(readModelProps, this)) return;

          this.context.store.dispatch(_actions2.default.unsubscribeReadmodel(this.readModelName, this.resolverName));

          this.context.store.dispatch(_actions2.default.subscribeReadmodel.apply(_actions2.default, (0, _toConsumableArray3.default)(extractReadModelValues(readModelProps))));

          (0, _assign2.default)(this, readModelProps);
        }
      }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
          var readModelProps = extractReadModelProps(mapStateToProps(this.context.store.getState(), this.props));

          this.context.store.dispatch(_actions2.default.subscribeReadmodel.apply(_actions2.default, (0, _toConsumableArray3.default)(extractReadModelValues(readModelProps))));

          (0, _assign2.default)(this, readModelProps);
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.context.store.dispatch(_actions2.default.unsubscribeReadmodel(this.readModelName, this.resolverName));
        }
      }, {
        key: 'render',
        value: function render() {
          return _react2.default.createElement(ConnectedComponent, this.props);
        }
      }]);
      return ReadModelConnector;
    }(_react2.default.PureComponent);

    ReadModelConnector.contextTypes = {
      store: _propTypes2.default.object.isRequired
    };

    return ReadModelConnector;
  };
};

module.exports = exports['default'];