'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _is_loading_view_model = require('./is_loading_view_model');

var _is_loading_view_model2 = _interopRequireDefault(_is_loading_view_model);

var _get_aggregate_actions = require('./get_aggregate_actions');

var _get_aggregate_actions2 = _interopRequireDefault(_get_aggregate_actions);

var _actions = require('./actions');

var _actions2 = _interopRequireDefault(_actions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (mapStateToProps, mapDispatchToProps, mergeProps, options) {
  return function (Component) {
    var ConnectedComponent = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps, mergeProps, options)(Component);

    var ViewModelConnector = function (_React$PureComponent) {
      (0, _inherits3.default)(ViewModelConnector, _React$PureComponent);

      function ViewModelConnector() {
        (0, _classCallCheck3.default)(this, ViewModelConnector);
        return (0, _possibleConstructorReturn3.default)(this, (ViewModelConnector.__proto__ || (0, _getPrototypeOf2.default)(ViewModelConnector)).apply(this, arguments));
      }

      (0, _createClass3.default)(ViewModelConnector, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
          var _mapStateToProps = mapStateToProps(this.context.store.getState(), this.props),
              viewModelName = _mapStateToProps.viewModelName,
              aggregateId = _mapStateToProps.aggregateId;

          this.viewModelName = viewModelName;
          this.aggregateId = aggregateId;

          this.context.store.dispatch(_actions2.default.subscribeViewmodel(this.viewModelName, this.aggregateId));
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          var _mapStateToProps2 = mapStateToProps(this.context.store.getState(), nextProps),
              viewModelName = _mapStateToProps2.viewModelName,
              aggregateId = _mapStateToProps2.aggregateId;

          if (viewModelName !== this.viewModelName || aggregateId !== this.aggregateId) {
            this.context.store.dispatch(_actions2.default.unsubscribeViewmodel(this.viewModelName, this.aggregateId));
            this.viewModelName = viewModelName;
            this.aggregateId = aggregateId;

            this.context.store.dispatch(_actions2.default.subscribeViewmodel(this.viewModelName, this.aggregateId));
          }
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.context.store.dispatch(_actions2.default.unsubscribeViewmodel(this.viewModelName, this.aggregateId));
        }
      }, {
        key: 'render',
        value: function render() {
          var loading = (0, _is_loading_view_model2.default)(this.context.store, this.viewModelName, this.aggregateId);
          var aggregateActions = (0, _get_aggregate_actions2.default)(this.context.store);

          return _react2.default.createElement(ConnectedComponent, (0, _extends3.default)({}, this.props, {
            loading: loading,
            aggregateActions: aggregateActions
          }));
        }
      }]);
      return ViewModelConnector;
    }(_react2.default.PureComponent);

    ViewModelConnector.contextTypes = {
      store: _propTypes2.default.object.isRequired
    };

    return ViewModelConnector;
  };
};

module.exports = exports['default'];