'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _util = require('./util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(store, action) {
    var command, aggregateId, aggregateName, payload, normalizedCommand, response, text;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            command = action.command, aggregateId = action.aggregateId, aggregateName = action.aggregateName, payload = action.payload;

            if (command && (0, _util.checkRequiredFields)({ aggregateId: aggregateId, aggregateName: aggregateName }, 'Send command error:', (0, _stringify2.default)(action)) && !(command.ok || command.error)) {
              _context.next = 3;
              break;
            }

            return _context.abrupt('return');

          case 3:
            normalizedCommand = {
              type: command.type,
              aggregateId: aggregateId,
              aggregateName: aggregateName,
              payload: payload
            };
            _context.prev = 4;
            _context.next = 7;
            return fetch((0, _util.getRootableUrl)('/api/commands'), {
              method: 'POST',
              headers: { 'Content-Type': 'application/json' },
              credentials: 'same-origin',
              body: (0, _stringify2.default)(normalizedCommand)
            });

          case 7:
            response = _context.sent;

            if (!response.ok) {
              _context.next = 11;
              break;
            }

            store.dispatch((0, _extends3.default)({}, action, {
              command: (0, _extends3.default)({}, action.command, {
                ok: true
              })
            }));

            return _context.abrupt('return');

          case 11:
            _context.next = 13;
            return response.text();

          case 13:
            text = _context.sent;

            // eslint-disable-next-line no-console
            console.error('Send command error:', text);
            throw new Error(text);

          case 18:
            _context.prev = 18;
            _context.t0 = _context['catch'](4);

            store.dispatch((0, _extends3.default)({}, action, {
              command: (0, _extends3.default)({}, action.command, {
                error: _context.t0
              })
            }));

          case 21:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[4, 18]]);
  }));

  function sendCommand(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return sendCommand;
}();

module.exports = exports['default'];